///////////////////////////////////////////////////////////////////////////////
//                   SOFTWARE COPYRIGHT NOTICE AGREEMENT                     //
//       This software and its documentation are copyright (2010) by the     //
//   Broad Institute.  All rights are reserved.  This software is supplied   //
//   without any warranty or guaranteed support whatsoever. The Broad        //
//   Institute is not responsible for its use, misuse, or functionality.     //
///////////////////////////////////////////////////////////////////////////////

/*
 * \file BinaryStream.cc
 * \author tsharpe
 * \date Aug 13, 2009
 *
 * \brief
 */
#ifndef FORCE_DEBUG
#define NDEBUG
#endif
#include "feudal/BinaryStream.h"
#include "system/Exit.h"
#include <iostream>

void BinaryWriter::close()
{
    if ( !mOS.flush() )
    {
        std::cout << "Writing binary file failed.  File is " <<
                    mFileName << '.' << std::endl;
        CRD::exit(1);
    }
    if ( mOFS.is_open() )
        mOFS.close();
}

void BinaryWriter::fail()
{
    std::cout << "Binary file writing has failed.  File is " <<
                mFileName  << '.' << std::endl;
    CRD::exit(1);
}

void BinaryReader::testToken()
{
    MagicToken tok;
    if ( !read(&tok).isValid() )
    {
        std::cout << "Binary file initial token is invalid.  File is " <<
                    mFileName << '.' << std::endl;
        CRD::exit(1);
    }
}

void BinaryReader::fail()
{
    std::cout << "Binary file reading has failed.  File is " <<
                    mFileName << '.' << std::endl;
    CRD::exit(1);
}
