///////////////////////////////////////////////////////////////////////////////
//                   SOFTWARE COPYRIGHT NOTICE AGREEMENT                     //
//       This software and its documentation are copyright (2010) by the     //
//   Broad Institute.  All rights are reserved.  This software is supplied   //
//   without any warranty or guaranteed support whatsoever. The Broad        //
//   Institute is not responsible for its use, misuse, or functionality.     //
///////////////////////////////////////////////////////////////////////////////


#ifndef SMITHWATBANDEDA
#define SMITHWATBANDEDA

#include "Alignment.h"
#include "Basevector.h"

float SmithWatBandedA( const basevector& S, const basevector& T, 
		       int offset, int bandwidth, align& a, int& errors, 
		       ostream* log = 0, int mis=2, int gap=3);

inline
float SmithWatBandedA( const basevector& S, const basevector& T, 
     int offset, int bandwidth, alignment& a, ostream *log = 0 )
{
  align temp; int errors;
  float result = SmithWatBandedA( S, T, offset, bandwidth, temp, errors, log );
  a.Set( temp, errors );
  return result;
}

#endif
