///////////////////////////////////////////////////////////////////////////////
//                   SOFTWARE COPYRIGHT NOTICE AGREEMENT                     //
//       This software and its documentation are copyright (2010) by the     //
//   Broad Institute.  All rights are reserved.  This software is supplied   //
//   without any warranty or guaranteed support whatsoever. The Broad        //
//   Institute is not responsible for its use, misuse, or functionality.     //
///////////////////////////////////////////////////////////////////////////////

#ifndef RANDOM_RANDOM_H
#define RANDOM_RANDOM_H

#include "system/Types.h"
#include <stdlib.h>

inline long randomx() { return random(); }

inline void srandomx( int x ) { srandom(x); }

// Although randomx returns a long, its actual range is that of a
// 31-bit int.  Therefore constructs like "randomx( ) % billion" are
// quite biased.  For this purpose, big_random is much better, as it
// produces a 62-bit random number:
inline longlong big_random()
{ return ( longlong( random() ) << 31 ) | longlong( random() );  }

#endif // RANDOM_RANDOM_H
